diff --speed-large-files --minimal -Nru tmp/alpine-2.20/imap/src/osdep/unix/maildir.h work/main.d/alpine-2.20/imap/src/osdep/unix/maildir.h
--- tmp/alpine-2.20/imap/src/osdep/unix/maildir.h	2015-03-18 20:17:43.000000000 -0600
+++ work/main.d/alpine-2.20/imap/src/osdep/unix/maildir.h	2015-03-28 13:55:34.000000000 -0600
@@ -224,3 +224,229 @@
 void maildir_assign_uid(MAILSTREAM *stream, unsigned long msgno, unsigned long uid);
 void maildir_uid_renew_tempfile(MAILSTREAM *stream);
 
+/* 
+ * A few definitions that try to make this module portable to other
+ * platforms (e.g. Cygwin). This module is based on the information from
+ * http://cr.yp.to/proto/maildir.html
+ */
+
+/* First we deal with the separator character */
+#ifndef FLAGSEP
+#define FLAGSEP ':'
+#endif
+#define SIZESEP ','
+
+const char sep1[] = {FLAGSEP, '1', ',', '\0'}; /* experimental semantics*/
+const char sep2[] = {FLAGSEP, '2', ',', '\0'}; /* Flags Information	*/
+const char sep3[] = {FLAGSEP, '3', ',', '\0'}; /* Grrrr....		*/
+
+const char *sep[] = { sep1, sep2, sep3, NULL};
+
+#define MDSEP(i)  sep[((i) - 1)]
+
+/* Now we deal with flags. Woohoo! */
+typedef enum  {Draft, Flagged, Passed, Replied, Seen, Trashed, 
+	       EmptyFlag, EndFlags} MdFlagNamesType;
+const int mdimapflags[] = {Draft, Flagged, Replied, Seen, Trashed, EmptyFlag, EndFlags};
+const int mdkwdflags[]  = {Passed, EmptyFlag, EndFlags};
+
+/* this array lists the codes for mdflgnms (maildir flag names) above */
+const char *mdflags[] = { "D", "F", "P", "R", "S", "T", "", NULL};
+/* and as characters too */
+const char cmdflags[] = { 'D', 'F', 'P', 'R', 'S', 'T', '0', '\0'};
+
+/* MDFLAG(Seen, elt->seen) */
+#define MDFLAG(i,j) mdflags[j ? (i) : EmptyFlag]
+/* MDFLAGC(Seen) */
+#define MDFLAGC(i) cmdflags[(i)]
+
+/* Now we deal with the directory structure */
+typedef enum {Cur, Tmp, New, EndDir} DirNamesType;
+char *mdstruct[] = {"cur", "tmp", "new", NULL};
+#define MDNAME(i) mdstruct[(i)]
+#define MDFLD(tmp, dir, i) sprintf((tmp),"%s/%s", (dir), mdstruct[(i)])
+#define MSGPATH(tmp, dir, msg,i) sprintf((tmp),"%s/%s/%s", (dir), mdstruct[(i)],(msg))
+
+/* Files associated to a maildir directory */
+
+#define MDUIDVALIDITY	".uidvalidity"	/* support for old maildirs    */
+#define MDDIR		".mdir"		/* this folder is a directory  */
+#define MDUIDLAST	".uidlast"	/* last assigned uid	       */
+#define MDUIDTEMP	".uidtemp"	/* We assign uid's no one else */
+
+
+
+/* Support of Courier Structure */
+#define CCLIENT 0
+#define COURIER 1
+#define IS_CCLIENT(t) \
+		(((t) && (t)[0] == '#' && ((t)[1] == 'm' || (t)[1] == 'M')\
+		&& ((t)[2] == 'd' || (t)[2] == 'D')\
+		&& (t)[3] == '/'  && (t)[4] != '\0') ? 1 : 0)
+
+#define IS_COURIER(t) \
+		(((t) && (t)[0] == '#' && ((t)[1] == 'm' || (t)[1] == 'M')\
+		&& ((t)[2] == 'c' || (t)[2] == 'C')\
+		&& (t)[3] == '/'  && (t)[4] != '\0') ? 1 : 0)
+#define MDPREFIX(s) ((s) ? "#mc/" : "#md/")
+#define MDSEPARATOR(s) ((s) ? '.' : '/')
+
+/* UID Support */
+
+#define MAXTEMPUID (unsigned long) 180L
+const char mduid[] = {',','u','=','\0'};
+#define MDUIDSEP mduid
+
+
+/* Now we deal with messages filenames */
+char mdlocaldomain[MAILTMPLEN+1] = {'\0'};
+pid_t mypid = (pid_t) 0;
+static char *mdfpath = NULL;
+static char myMdInboxDir[50] = { '\0' };/* Location of the Maildir INBOX */
+static long CourierStyle = CCLIENT;
+
+#define CHUNK	16384	/* from unix.h */
+
+typedef struct courier_local {
+  char *name;		/* name of directory/folder */
+  int attribute;	/* attributes (children/marked/etc) */
+} COURIERLOCAL;
+
+typedef struct courier {
+  char *path;			/* Path to collection */
+  time_t scantime;		/* time at which information was generated */
+  int total;			/* total number of elements in data */
+  COURIERLOCAL **data;
+} COURIER_S;
+
+/* In gdb this is the  *(struct maildir_local *)stream->local structure */
+typedef struct maildir_local {
+  unsigned int dirty : 1;	/* diskcopy needs updating 		*/
+  unsigned int courier : 1;	/* It is Courier style file system	*/
+  unsigned int link : 1;	/* There is a symbolic link		*/
+  int candouid;			/* we can assign uids and no one else	*/
+  char *uidtempfile;		/* path to uid temp file		*/
+  int fd;			/* fd of open message			*/
+  char *dir;			/* mail directory name			*/
+  char **path;			/* path to directories cur, new and tmp	*/
+  unsigned char *buf;		/* temporary buffer 			*/
+  unsigned long buflen;		/* current size of temporary buffer 	*/
+  time_t scantime;		/* last time directory scanned 		*/
+} MAILDIRLOCAL;
+
+/* Convenient access to local data */
+#define LOCAL ((MAILDIRLOCAL *) stream->local)
+
+typedef struct maildir_file_info {
+   char *name;		/* name of the file			   */
+   DirNamesType loc;	/* location of this file		   */
+   unsigned long pos;	/* place in list where this file is listed */
+   off_t size;		/* size in bytes, on disk */
+   time_t atime;	/* last access time */
+   time_t mtime;	/* last modified time */
+   time_t ctime;	/* last changed time */
+} MAILDIRFILE;
+
+#define MDFILE(F) (((MAILDIRFILE *)((F)->private.spare.ptr))->name)
+#define MDLOC(F)  (((MAILDIRFILE *)((F)->private.spare.ptr))->loc)
+#define MDPOS(F)  (((MAILDIRFILE *)((F)->private.spare.ptr))->pos)
+#define MDSIZE(F)  (((MAILDIRFILE *)((F)->private.spare.ptr))->size)
+#define MDATIME(F)  (((MAILDIRFILE *)((F)->private.spare.ptr))->atime)
+#define MDMTIME(F)  (((MAILDIRFILE *)((F)->private.spare.ptr))->mtime)
+#define MDCTIME(F)  (((MAILDIRFILE *)((F)->private.spare.ptr))->ctime)
+
+/* Function prototypes */
+
+DRIVER *maildir_valid (char *name);
+MAILSTREAM *maildir_open (MAILSTREAM *stream);
+void maildir_close (MAILSTREAM *stream, long options);
+long maildir_ping (MAILSTREAM *stream);
+void maildir_check (MAILSTREAM *stream);
+long maildir_text (MAILSTREAM *stream,unsigned long msgno,STRING *bs,long flags);
+char *maildir_header (MAILSTREAM *stream,unsigned long msgno,
+		unsigned long *length, long flags);
+void maildir_list (MAILSTREAM *stream,char *ref,char *pat);
+void *maildir_parameters (long function,void *value);
+int maildir_create_folder (char *mailbox);
+long maildir_create (MAILSTREAM *stream,char *mailbox);
+void maildir_flagmsg (MAILSTREAM *stream,MESSAGECACHE *elt); /*check */
+long maildir_expunge (MAILSTREAM *stream, char *sequence, long options);
+long maildir_copy (MAILSTREAM *stream,char *sequence,char *mailbox,long options);
+long maildir_append (MAILSTREAM *stream,char *mailbox, append_t af, void *data);
+long maildir_delete (MAILSTREAM *stream,char *mailbox);
+long maildir_rename (MAILSTREAM *stream,char *old,char *new);
+long maildir_sub (MAILSTREAM *stream,char *mailbox);
+long maildir_unsub (MAILSTREAM *stream,char *mailbox);
+void maildir_lsub (MAILSTREAM *stream,char *ref,char *pat);
+void courier_list (MAILSTREAM *stream,char *ref, char *pat);
+
+/* utility functions */
+void courier_realname (char *name, char *realname);
+long maildir_dirfmttest (char *name);
+char *maildir_file (char *dst,char *name);
+int maildir_select (const struct direct *name);
+int maildir_namesort (const struct direct **d1, const struct direct **d2);
+unsigned long antoul (char *seed);
+unsigned long mdfntoul (char *name);
+int courier_dir_select (const struct direct *name);
+int courier_dir_sort (const struct direct **d1, const struct direct **d2);
+long maildir_canonicalize (char *pattern,char *ref,char *pat);
+void maildir_list_work (MAILSTREAM *stream,char *subdir,char *pat,long level);
+void courier_list_work (MAILSTREAM *stream,char *subdir,char *pat,long level);
+int maildir_file_path(char *name, char *tmp, size_t sizeoftmp);
+int maildir_valid_name (char *name);
+int maildir_valid_dir (char *name);
+int is_valid_maildir (char **name);
+int maildir_message_exists(MAILSTREAM *stream,char *name, char *tmp);
+char *maildir_remove_root(char *name);
+char *maildir_text_work (MAILSTREAM *stream,MESSAGECACHE *elt, unsigned long *length,long flags);
+unsigned long  maildir_parse_message(MAILSTREAM *stream, unsigned long msgno, 
+						DirNamesType dirtype);
+int maildir_eliminate_duplicate (char *name, struct direct ***flist, 
+					unsigned long *nfiles);
+int maildir_doscandir (char *name, struct direct ***flist, int flag);
+unsigned long maildir_scandir (char *name, struct direct ***flist,
+			unsigned long *nfiles, int *scand, int flag);
+void maildir_parse_folder (MAILSTREAM *stream, int full);
+void  md_domain_name (void);
+char  *myrootdir (char *name);
+char  *mdirpath (void);
+int   maildir_initial_check (MAILSTREAM *stream, DirNamesType dirtype);
+unsigned long  maildir_parse_dir(MAILSTREAM *stream, unsigned long nmsgs, 
+   DirNamesType dirtype, struct direct **names, unsigned long nfiles, int full);
+int same_maildir_file(char *name1, char *name2);
+int comp_maildir_file(char *name1, char *name2);
+int maildir_message_in_list(char *msgname, struct direct **names,
+		unsigned long bottom, unsigned long top, unsigned long *pos);
+void maildir_getflag(char *name, int *d, int *f, int *r ,int *s, int *t);
+int maildir_update_elt_maildirp(MAILSTREAM *stream, unsigned long msgno);
+void maildir_abort (MAILSTREAM *stream);
+int maildir_contains_folder(char *dirname, char *name);
+int maildir_is_dir(char *dirname, char *name);
+int maildir_dir_is_empty(char *mailbox);
+int maildir_create_work (char *mailbox, int loop);
+void maildir_get_file (MAILDIRFILE **mdfile);
+void maildir_free_file (void **mdfile);
+void maildir_free_file_only (void **mdfile);
+int maildir_any_new_msgs(char *mailbox);
+void maildir_get_date(MAILSTREAM *stream, unsigned long msgno);
+void maildir_fast (MAILSTREAM *stream,char *sequence,long flags);
+
+/* Courier server support */
+void courier_free_cdir (COURIER_S **cdir);
+COURIER_S *courier_get_cdir (int total);
+int courier_search_list(COURIERLOCAL **data, char *name, int first, int last);
+COURIER_S *courier_list_dir(char *curdir);
+void courier_list_info(COURIER_S **cdirp, char *data, int i);
+
+/* UID Support */
+int maildir_can_assign_uid (MAILSTREAM *stream);
+void maildir_read_uid(MAILSTREAM *stream, unsigned long *uid_last, 
+     			                   unsigned long *uid_validity);
+void maildir_write_uid(MAILSTREAM *stream, unsigned long uid_last, 
+     			                   unsigned long uid_validity);
+unsigned long maildir_get_uid(char *name);
+void maildir_delete_uid(MAILSTREAM *stream, unsigned long msgno);
+void maildir_assign_uid(MAILSTREAM *stream, unsigned long msgno, unsigned long uid);
+void maildir_uid_renew_tempfile(MAILSTREAM *stream);
+
diff --speed-large-files --minimal -Nru tmp/alpine-2.20/pith/pine.hlp work/main.d/alpine-2.20/pith/pine.hlp
--- tmp/alpine-2.20/pith/pine.hlp	2015-03-18 20:17:44.000000000 -0600
+++ work/main.d/alpine-2.20/pith/pine.hlp	2015-03-28 13:55:43.000000000 -0600
@@ -22319,6 +22319,102 @@
 &lt;End of help on this topic&gt;
 </BODY>
 </HTML>
+====== h_config_maildir_location ======
+<HTML>
+<HEAD>
+<TITLE>OPTION: <!--#echo var="VAR_maildir-location"--></TITLE>
+</HEAD>
+<BODY>
+<H1>OPTION: <!--#echo var="VAR_maildir-location"--></H1>
+
+<P>
+This option should be used only if you have a Maildir folder which you
+want to use as your INBOX. If this is not your case (or don't know what
+this is), you can safely ignore this option.
+
+<P>
+This option overrides the default directory Pine uses to find the location of
+your INBOX, in case this is in Maildir format. The default value of this
+option is "Maildir", but in some systems, this directory could have been
+renamed (e.g. to ".maildir"). If this is your case use this option to change
+the default.
+
+<P>
+The value of this option is prefixed with the "~/" string to determine the
+full path to your INBOX.
+
+<P>
+You should probably <A HREF="h_config_maildir">read</A> a few tips that 
+teach you how to configure your maildir for optimal performance. This
+version also has <A HREF="h_config_courier_list">support</A> for the 
+Courier style file system when a maildir collection is accessed locally.
+
+<P><UL>
+<LI><A HREF="h_finding_help">Finding more information and requesting help</A>
+</UL>
+<P>
+&lt;End of help on this topic&gt;
+</BODY>
+</HTML>
+====== h_config_maildir =====
+<HTML>
+<HEAD>
+<TITLE>Maildir Support</TITLE>
+</HEAD>
+<BODY>
+<H1>Maildir Support</H1>
+
+This version of Alpine has been enhanced with Maildir support. This text is 
+intended to be a reference on its support.
+<P>
+
+A Maildir folder is a directory that contains three directories called 
+cur, tmp and new. A program that delivers mail (e.g. postfix) will put new 
+mail in the new directory. A program that reads mail will look for for old 
+messages in the cur directory, while it will look for new mail in the new 
+directory.
+<P>
+
+In order to use maildir support it is better to set your inbox-path to the 
+value &quot;#md/inbox&quot; (without quotes). This assumes that your mail 
+delivery agent is delivering new mail to ~/Maildir/new. If the directory 
+where new mail is being delivered is not called "Maildir", you can set the 
+name of the subdirectory of home where it is being delivered in the <A 
+HREF="h_config_maildir_location"><!--#echo var="VAR_maildir-location"--></A> configuration 
+variable. Most of the time you will not have to worry about the 
+<!--#echo var="VAR_maildirlocation"--> variable, because it will probably be set by your 
+administrator in the pine.conf configuration file.
+<P>
+
+One of the advantages of the Maildir support of this version of Alpine is 
+that you do not have to stop using folders in another styles (mbox, mbx, 
+etc.). This is desirable since the usage of a specific mail storage system 
+is a personal decision. Folders in the maildir format that are part of the 
+Mail collection will be recognized without any extra configuration of your 
+part. If your mail/ collection is located under the mail/ directory, then 
+creating a new maildir folder in this collection is done by pressing "A" 
+and entering the string "#driver.md/mail/newfolder". Observe that adding a 
+new folder as "newfolder" may not create such folder in maildir format.
+
+<P>
+If you would like to have all folders created in the maildir format by 
+default, you do so by adding a Maildir Collection. In order to convert 
+your current mail/ collection into a maildir collection, edit the 
+collection and change the path variable from &quot;mail/&quot; to 
+&quot;#md/mail&quot;. In a maildir collection folders of any other format 
+are ignored.
+
+<P> Finally, This version also has 
+<A HREF="h_config_courier_list">support</A> for the Courier style file system 
+when a maildir collection is accessed locally.
+
+<P>
+<UL>   
+<LI><A HREF="h_finding_help">Finding more information and requesting help</A>
+</UL><P>
+&lt;End of help on this topic&gt;
+</BODY>
+</HTML>
 ====== h_config_literal_sig =====
 <HTML>
 <HEAD>
@@ -31490,6 +31586,49 @@
 &lt;End of help on this topic&gt;
 </BODY>
 </HTML>
+====== h_config_courier_list =====
+<HTML>
+<HEAD>
+<TITLE>FEATURE: <!--#echo var="FEAT_courier-folder-list"--></TITLE>
+</HEAD>
+<BODY>
+<H1>FEATURE: <!--#echo var="FEAT_courier-folder-list"--></H1>
+
+In a maildir collection, a folder could be used as a directory to store 
+folders. In the Courier server if you create a folder, then a directory 
+with the same name is created. If you use this patch to access a 
+collection created by the Courier server, then the display of such 
+collection will look confusing. The best way to access a maildir 
+collection created by the Courier server is by using the &quot;#mc/&quot; 
+prefix instead of the &quot;#md/&quot; prefix. If you use this alternate 
+prefix, then this feature applies to you, otherwise you can safely ignore 
+the text that follows.
+<P>
+Depending on if you have enabled the option 
+<a href="h_config_separate_fold_dir_view"><!--#echo var="FEAT_separate-folder-and-directory-entries"--></a> 
+a folder may be listed as &quot;folder[.]&quot;, or as two entries in the 
+list by &quot;folder&quot; and &quot;folder.&quot;.
+<P>
+If this option is disabled, Pine will list local folders that are in Courier
+style format, as &quot;folder&quot;, and those that are also directories as
+&quot;folder[.]&quot;. This makes the default display cleaner.
+<P>
+If this feature is enabled then creating folders in a maildir collection
+will create a directory with the same name. If this feature is disabled, then 
+a folder is considered a directory only if it contains subfolders, so you can
+not create a directory with the same name as an exisiting folder unless 
+you create a subfolder of that folder first (e.g. if you have a folder
+called &quot;foo&quot; simply add &quot;foo.bar&quot; directly. This will
+create the directory &quot;foo&quot; and the subfolder &quot;bar&quot; of it).
+<P>
+Observe that this feature works only for maildir collections that are accessed
+locally. If a collection is accessed remotely then this feature has no value,
+as the report is created in a server, and Pine only reports what received
+from the server in this case.
+<P>
+&lt;End of help on this topic&gt;
+</BODY>
+</HTML>
 ====== h_config_verbose_post =====
 <HTML>
 <HEAD>
